import { Buff, Bytes } from '@cmdcode/buff-utils';
import { Field, Point } from './ecc.js';
import { getXOnlyPub } from './utils.js';
import { SignerConfig, SignerOptions } from './signer.js';
export declare class SecretKey extends Uint8Array {
    static random(config?: SignerConfig): SecretKey;
    readonly opt: SignerOptions;
    constructor(secret: Bytes, config?: SignerConfig);
    get buff(): Buff;
    get raw(): Uint8Array;
    get hex(): string;
    get field(): Field;
    get point(): Point;
    get pub(): PublicKey;
    get hasEvenY(): boolean;
    get hasOddY(): boolean;
    get xonly(): SecretKey;
    add(bytes: Bytes): SecretKey;
    sub(bytes: Bytes): SecretKey;
    mul(bytes: Bytes): SecretKey;
    div(bytes: Bytes): SecretKey;
    pow(bytes: Bytes): SecretKey;
    negate(): SecretKey;
    sign(message: Bytes, config?: SignerConfig): Buff;
    verify(signature: Bytes, message: Bytes, config?: SignerConfig): boolean;
    toWIF(prefix?: number): string;
}
export declare class PublicKey extends Uint8Array {
    static from_secret(bytes: Bytes, config?: SignerConfig): PublicKey;
    static xonly: typeof getXOnlyPub;
    readonly opt: SignerOptions;
    constructor(pubkey: Bytes, config?: SignerConfig);
    get buff(): Buff;
    get raw(): Uint8Array;
    get hex(): string;
    get point(): Point;
    get x(): Buff;
    get y(): Buff;
    get hasOddY(): boolean;
    add(key: Bytes | PublicKey): PublicKey;
    sub(key: Bytes | PublicKey): PublicKey;
    mul(key: Bytes | PublicKey): PublicKey;
    negate(): PublicKey;
    verify(signature: Bytes, message: Bytes, config?: SignerConfig): boolean;
}
export declare const KeyPair: typeof SecretKey;
//# sourceMappingURL=keypair.d.ts.map